[leetcode] 198. House Robber

题目

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

翻译:

你是一条街上房子的偷盗者,每个房子里都有一定数量的现金,不能同时抢劫相邻的两座房子,问最多能抢劫多少钱

题解:

这道题的本质相当于在一列数组中取出一个或多个不相邻数,使其和最大。那么我们对于这类求极值的问题首先考虑动态规划Dynamic Programming来解,我们维护一个一位数组dp,其中dp[i]表示到i个房子时不相邻数能形成的最大和,那么递推公式怎么写呢,我们先拿一个简单的例子来分析一下,比如说nums为{3, 2, 1, 5},那么我们来看我们的dp数组应该是什么样的,首先dp[1]=3没啥疑问,再看dp[2]是多少呢,由于3比2大,所以我们抢第一个房子的3,当前房子的2不抢,所以dp[2]=3,那么再来看dp[3],由于不能抢相邻的,所以我们可以用再前面的一个的dp值加上当前的房间值,和当前房间的前面一个dp值比较,取较大值当做当前dp值,所以我们可以得到递推公式dp[i] = max(num[i-1] + dp[i - 2], dp[i - 1]),

	public int rob(int[] nums){
		if(nums.length>0){
			int[] dp=new int[nums.length+1];
			dp[0]=0;
			dp[1]=nums[0];
			for(int i=2;i<nums.length+1;i++)
				dp[i]=Math.max(dp[i-1], dp[i-2]+nums[i-1]);
			return dp[nums.length];
		}else
			return 0;
	}

这里注意一下,同样是动态规划,如果用递归方式实现的话,时间会超时,下面是因为时间超时没通过的错误示例

	public int rob(int[] nums){
		if(nums.length>=1)
			return dp(nums.length-1,nums);
		else
			return 0;
	}
	
	public int dp(int n,int[] nums){
		if(n==0)
			return nums[0];
		if(n==1)
			return nums[0]>nums[1]?nums[0]:nums[1];
		return dp(n-1,nums)>dp(n-2,nums)+nums[n]?dp(n-1,nums):dp(n-2,nums)+nums[n];
	}
	


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值